from dash import dcc, html
import dash_daq as daq

def time_before_filter_object(default=0):
    time_before_input = dcc.Input(
            id="time-before-activity-filter",
            type="number",
            value=default,
            min=0, 
            size=2,
            style={'float': 'left','margin-left': '4px', 'margin-right': '4px', 'width': '36px'})
    time_before_filter = html.Div([html.P('Remove activities occuring less than ', style={'float': 'left','margin': 'auto', 'margin-top': '4px'}), 
                                time_before_input, 
                                html.P(' seconds than the previous one', style={'float': 'left','margin': 'auto', 'margin-top': '4px'})])
    return time_before_filter

def dropdown_excluded_activities(activity_count_df, events_filters):
    return dcc.Dropdown(id='excluded-activities-dropdown',
                             options=[
           {'label': activity, 'value': activity}
        for activity in activity_count_df['activity']],
                             value=events_filters,
                             multi=True,
                       style={'border-radius': 0})

def remove_self_transition(self_transition):
    return daq.BooleanSwitch(id='self-transition',
                               on=self_transition,
                               persistence=False,
                               style={'float': 'left'})