# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# -*- coding: utf-8 -*-
import dataiku
import pandas as pd, numpy as np
from dataiku import pandasutils as pdu
from process_mining.graph_creation import create_graph
import pydot
from cairosvg import svg2png

# Read recipe inputs
workflow_mined_summary = dataiku.Dataset("workflow_mined_summary")
workflow_mined_summary_df = workflow_mined_summary.get_dataframe()
reference_process_start_end = dataiku.Dataset("reference_process_start_end")
reference_process_start_end_df = reference_process_start_end.get_dataframe()
reference_process_activities_conformity = dataiku.Dataset("reference_process_activities_conformity_prepared")
reference_process_activities_conformity_df = reference_process_activities_conformity.get_dataframe()

name = 'conformance_graph'

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
workflow_mined_summary_df = workflow_mined_summary_df[workflow_mined_summary_df['source'].isin(reference_process_activities_conformity_df['step'])]

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
graph, _, _ = create_graph(workflow_mined_summary_df, reference_process_start_end_df, reference_process_activities_conformity_df)

dot_graph = pydot.graph_from_dot_data(graph)
folder_id = 'zRxQZ0BL'
svg = dot_graph[0].create_svg()
png = svg2png(svg)
dss_folder = dataiku.Folder(folder_id)
with dss_folder.get_writer(name + '.png') as w:
    w.write(png)